#! /bin/sh
#
# Uninstall the pepsy system from ISODE
# Assumes pepsy was installed with the shell script and uses the backed up
# version of the files
#

# restore all the directories from back up
if test -d others/pepsy
    then
	/bin/rm -rf others/pepsy
	echo pepsy removed
    else
	echo pepsy stuff missing
fi
exit 1
# don't need this any more 
#
for dir in psap2 acsap ftam ftam2 posy
    do
    if test -d $dir.orig
	then
	    echo "$dir backup found"
	else
	    echo "$dir backup not found: warning $0 may not have worked"
	    continue
    fi

    if /bin/rm -fr $dir
       then
	   :
       else
	   echo "cannot remove $dir: $0 failed"
	   exit 1;
    fi

    if mv $dir.orig $dir
	then
	    echo $dir restored
	else
	    echo "$dir cannot be restored: $0 failed"
	    exit 2
    fi
done
